unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls;

procedure OnCheckPrepare(Progress: Integer); stdcall;
procedure OnError(ErrorCode: Integer; ErrorMsg: PChar); stdcall;
procedure OnCloseCheck; stdcall;

type
//------------------------------------------------------------------------------
//          chon100.dll
//------------------------------------------------------------------------------
  TAppCheckPrepare = procedure(Progress: Integer); stdcall;
  TAppError = procedure (ErrorCode: Integer; ErrorMsg: PChar); stdcall;
  TAppEvent = procedure; stdcall;
//------------------------------------------------------------------------------
  TDemoForm = class(TForm)
    PageControl: TPageControl;
    TopPanel: TPanel;
    CheckTabSheet: TTabSheet;
    cbAddBottomLineButton: TButton;
    cbAddSaleButton: TButton;
    cbAddTitleLineButton: TButton;
    cbClearBottomButton: TButton;
    cbClearTitleButton: TButton;
    ReadTitleButton: TButton;
    ReadBottomButton: TButton;
    cbClearSalesButton: TButton;
    GetCheckButton: TButton;
    CheckParamButton: TButton;
    CommonTabSheet: TTabSheet;
    GetCashSumButton: TButton;
    GetKKMNumButton: TButton;
    GetKLNumButton: TButton;
    GetNIButton: TButton;
    GetSaleNumButton: TButton;
    GetKKMVersButton: TButton;
    ReadSaleFromKLButton: TButton;
    AdditionTabSheet: TTabSheet;
    LockButton: TButton;
    UnLockButton: TButton;
    GroupBox1: TGroupBox;
    CodeEdit: TEdit;
    PortCombo: TComboBox;
    ConnectButton: TButton;
    Label2: TLabel;
    Label1: TLabel;
    ProgressBar: TProgressBar;
    CloseCheckBox: TCheckBox;
    ProgressCheckBox: TCheckBox;
    ErrorCheckBox: TCheckBox;
    SendSalesButton: TButton;
    Label3: TLabel;
    KKMPrintStrButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure CodeEditKeyPress(Sender: TObject; var Key: Char);
    procedure ConnectButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cbAddBottomLineButtonClick(Sender: TObject);
    procedure cbAddTitleLineButtonClick(Sender: TObject);
    procedure cbClearBottomButtonClick(Sender: TObject);
    procedure cbClearTitleButtonClick(Sender: TObject);
    procedure ReadTitleButtonClick(Sender: TObject);
    procedure ReadBottomButtonClick(Sender: TObject);
    procedure cbAddSaleButtonClick(Sender: TObject);
    procedure cbClearSalesButtonClick(Sender: TObject);
    procedure GetCheckButtonClick(Sender: TObject);
    procedure CheckParamButtonClick(Sender: TObject);
    procedure GetCashSumButtonClick(Sender: TObject);
    procedure GetKKMNumButtonClick(Sender: TObject);
    procedure GetKLNumButtonClick(Sender: TObject);
    procedure GetNIButtonClick(Sender: TObject);
    procedure GetSaleNumButtonClick(Sender: TObject);
    procedure GetKKMVersButtonClick(Sender: TObject);
    procedure ReadSaleFromKLButtonClick(Sender: TObject);
    procedure LockButtonClick(Sender: TObject);
    procedure UnLockButtonClick(Sender: TObject);
    procedure SendSalesButtonClick(Sender: TObject);
    procedure KKMPrintStrButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

//------------------------------------------------------------------------------
//                         
//------------------------------------------------------------------------------
  function cbAddBottomLine(Line: PChar): Integer; stdcall; external 'km100.dll';
  function cbAddSale(Name: PChar; Price, Qty: Double; Section: Integer): Integer; stdcall; external 'km100.dll';
  function cbAddTitleLine(Line: PChar): Integer; stdcall; external 'km100.dll';
  function cbGetBottomLinesCount: Integer; stdcall; external 'km100.dll';
  procedure cbClearBottom; stdcall; external 'km100.dll';
  procedure cbSetCreditMode(Mode: Integer); stdcall; external 'km100.dll';
  function cbGetCreditMode: Integer; stdcall; external 'km100.dll';
  procedure cbClearSales; stdcall; external 'km100.dll';
  procedure cbClearTitle; stdcall; external 'km100.dll';
      function cbDeleteSale(Index: Integer): Integer; stdcall; external 'km100.dll';
  function cbGetBottomLine(Index: Integer; var Line: PChar): Integer; stdcall; external 'km100.dll';
  function cbGetDiscountValue: Integer; stdcall; external 'km100.dll';
  function cbGetSale(Index: Integer; var Name: PChar; var Price, Qty: Double; var Section: Integer): Integer; stdcall; external 'km100.dll';
  function cbGetTitleLine(Index: Integer; var Line: PChar): Integer; stdcall; external 'km100.dll';
  function cbGetSalesCount: Integer; stdcall; external 'km100.dll';
  procedure cbSetReturnMode(Mode: Integer); stdcall; external 'km100.dll';
  function cbGetReturnMode: Integer; stdcall; external 'km100.dll';
  function cbSetCash(Value: Double): Integer; stdcall; external 'km100.dll';
  function cbGetCash: Double; stdcall; external 'km100.dll';
  function cbSetDiscountValue(Value: Integer): Integer; stdcall; external 'km100.dll';
  function cbGetSum: Double; stdcall; external 'km100.dll';
  function cbGetTitleLinesCount: Integer; stdcall; external 'km100.dll';
      procedure cbSetClearBufMode(Mode: Integer); stdcall; external 'km100.dll';
      function cbGetClearBufMode: Integer; stdcall; external 'km100.dll';
  function ConnectKKM(Port: Integer): Integer; stdcall; external 'km100.dll';
  procedure DisconnectKKM; stdcall; external 'km100.dll';
  function GetDiscountMode: Integer; stdcall; external 'km100.dll';
      function GetErrorCode: Integer; stdcall; external 'km100.dll';
  function GetErrorMsg: PChar; stdcall; external 'km100.dll';
  function GetCashSum(var Sum: Double): Integer; stdcall; external 'km100.dll';
  function GetKKMNum(var KKMNum: Integer): Integer; stdcall; external 'km100.dll';
  function GetKLNum(var KLNum: Integer): Integer; stdcall; external 'km100.dll';
  function GetNI(var NI: Double): Integer; stdcall; external 'km100.dll';
  function GetSaleNum(var SaleNum: Integer): Integer; stdcall; external 'km100.dll';
  function GetKKMVers: Integer; stdcall; external 'km100.dll';
  function Lock: Integer; stdcall; external 'km100.dll';
  function ReadSaleFromKL(SaleNum: Integer; var Operation, Section,
           Cashier, Discount, Credit, StartCheck, H, M: Integer; var Sum: Double): Integer; stdcall; external 'km100.dll';
  procedure SetSupplierCode(Code: PChar); stdcall; external 'km100.dll';
  function UnLock: Integer; stdcall; external 'km100.dll';
  procedure SetChPrepareEvent(Ptr: TAppCheckPrepare); stdcall; external 'km100.dll';
  procedure SetErrorEvent(Ptr: TAppError); stdcall; external 'km100.dll';
  procedure SetQueryEvent(Ptr: TAppEvent); stdcall; external 'km100.dll';
  procedure SetCloseCheckEvent(Ptr: TAppEvent); stdcall; external 'km100.dll';
  function SendSales: Integer; stdcall; external 'km100.dll';
  function KKMPrintStr(Str: PChar): Integer; stdcall; external 'km100.dll';

//------------------------------------------------------------------------------

var
  DemoForm: TDemoForm;

implementation
uses
  LineEdit, SaleEdit, List, CheckParam, NumEdit;

{$R *.DFM}

//------------------------------------------------------------------------------
//       ,     
//------------------------------------------------------------------------------
procedure OnCheckPrepare(Progress: Integer);
begin
  if not DemoForm.ProgressCheckBox.Checked then
    begin
      if DemoForm.ProgressBar.Visible then DemoForm.ProgressBar.Visible:=False;
      Exit;
    end;
  Application.ProcessMessages;
  if Progress = 0 then
    begin
      DemoForm.ProgressBar.Position:=0;
      DemoForm.ProgressBar.Visible:=True;
    end;
  DemoForm.ProgressBar.Position:=Progress;
  if Progress = 100 then
    begin
      Sleep(300);
      DemoForm.ProgressBar.Visible:=False;
    end;
end;

//------------------------------------------------------------------------------
//     ,     
//------------------------------------------------------------------------------
procedure OnError(ErrorCode: Integer; ErrorMsg: PChar); 
begin
  if DemoForm.ErrorCheckBox.Checked then
    ShowMessage('chon100.dll    .'+#13+#10+
                '  = '+IntToStr(ErrorCode)+'  : '+ErrorMsg);
end;

//------------------------------------------------------------------------------
//     ,      
//------------------------------------------------------------------------------
procedure OnCloseCheck;
begin
  if DemoForm.CloseCheckBox.Checked then ShowMessage('   .');
end;

//------------------------------------------------------------------------------
//                       
//------------------------------------------------------------------------------
procedure TDemoForm.FormCreate(Sender: TObject);
begin
  PortCombo.ItemIndex:=0;
  SetChPrepareEvent(OnCheckPrepare);
  SetErrorEvent(OnError);          
  SetCloseCheckEvent(OnCloseCheck);
end;

//------------------------------------------------------------------------------
//             
//------------------------------------------------------------------------------
procedure TDemoForm.CodeEditKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key>='0') and (Key<='9') then Exit;
  if Key=#8 then Exit;
  Key:=#7;
end;

//------------------------------------------------------------------------------
//                     
//------------------------------------------------------------------------------
procedure TDemoForm.ConnectButtonClick(Sender: TObject);
begin
  SetSupplierCode(PChar(CodeEdit.Text));
  ConnectKKM(PortCombo.ItemIndex+1);
  ShowMessage(GetErrorMsg);
end;

//------------------------------------------------------------------------------
//                       
//------------------------------------------------------------------------------
procedure TDemoForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  DisconnectKKM;
end;

//------------------------------------------------------------------------------
//                     
//------------------------------------------------------------------------------
procedure TDemoForm.cbAddBottomLineButtonClick(Sender: TObject);
begin
  LineEditForm.Edit.MaxLength:=24;
  if LineEditForm.ShowModal <> mrOk then Exit;
  if cbAddBottomLine(PChar(LineEditForm.Edit.Text))<>1 then
    ShowMessage(GetErrorMsg);
end;

//------------------------------------------------------------------------------
//                     
//------------------------------------------------------------------------------
procedure TDemoForm.cbAddTitleLineButtonClick(Sender: TObject);
begin
  LineEditForm.Edit.MaxLength:=24;
  if LineEditForm.ShowModal <> mrOk then Exit;
  if cbAddTitleLine(PChar(LineEditForm.Edit.Text))<>1 then
    ShowMessage(GetErrorMsg);
end;

//------------------------------------------------------------------------------
//                          
//------------------------------------------------------------------------------
procedure TDemoForm.cbClearBottomButtonClick(Sender: TObject);
begin
  cbClearBottom;
end;

//------------------------------------------------------------------------------
//                          
//------------------------------------------------------------------------------
procedure TDemoForm.cbClearTitleButtonClick(Sender: TObject);
begin
  cbClearTitle;
end;

//------------------------------------------------------------------------------
//                         
//------------------------------------------------------------------------------
procedure TDemoForm.ReadTitleButtonClick(Sender: TObject);
var
  i, Count: Integer;
  ResultStr: String;
  TempLine: PChar;
  S: String[24];
begin
  Count:=cbGetTitleLinesCount; //   
  ResultStr:='';
  TempLine:=@S;
  for i:=1 to Count do
    begin
      if cbGetTitleLine(i, TempLine)<>1 then  // 
        begin
          ShowMessage(GetErrorMsg);
          Exit;
        end;
      ResultStr:=ResultStr+String(TempLine)+#13+#10;
    end;
  ShowMessage(ResultStr);
end;

//------------------------------------------------------------------------------
//                         
//------------------------------------------------------------------------------
procedure TDemoForm.ReadBottomButtonClick(Sender: TObject);
var
  i, Count: Integer;
  ResultStr: String;
  TempLine: PChar;
  S: String[24];
begin
  Count:=cbGetBottomLinesCount;  //   
  ResultStr:='';
  TempLine:=@S;
  for i:=1 to Count do
    begin
      if cbGetBottomLine(i, TempLine)<>1 then  // 
        begin
          ShowMessage(GetErrorMsg);
          Exit;
        end;
      ResultStr:=ResultStr+String(TempLine)+#13+#10;
    end;
  ShowMessage(ResultStr);
end;

//------------------------------------------------------------------------------
//                   
//------------------------------------------------------------------------------
procedure TDemoForm.cbAddSaleButtonClick(Sender: TObject);
begin
  if SaleForm.ShowModal <> mrOk then Exit;
  with SaleForm do
    if cbAddSale(PChar(NameEdit.Text),StrToFloat(PriceEdit.Text),
                 StrToFloat(QtyEdit.Text),SectionEdit.Value) <> 1 then
      begin
        ShowMessage(GetErrorMsg);
        Exit;
      end;
end;

//------------------------------------------------------------------------------
//                     
//------------------------------------------------------------------------------
procedure TDemoForm.cbClearSalesButtonClick(Sender: TObject);
begin
  cbClearSales;
end;

//------------------------------------------------------------------------------
//                   
//------------------------------------------------------------------------------
procedure TDemoForm.GetCheckButtonClick(Sender: TObject);
var
  i: Integer;
  S: String[51];
  Name: PChar;
  Price, Qty: Double;
  Section: Integer;
  ListItem: TListItem;
  SaleCount: Integer;
begin
  Name:=@S;
  ListForm.ListView.Items.Clear;
  SaleCount:=cbGetSalesCount;
  for i:=1 to SaleCount do
    begin
      if cbGetSale(i,Name,Price,Qty,Section) <> 1 then
        begin
          ShowMessage(GetErrorMsg);
          Exit;
        end;
      ListItem:=ListForm.ListView.Items.Add;
      ListItem.Caption:=IntToStr(Section);
      ListItem.SubItems.Add(String(Name));
      ListItem.SubItems.Add(FormatFloat('0.00',Price));
      ListItem.SubItems.Add(FormatFloat('0.000',Qty));
    end;
  if cbGetCreditMode = 1 then
    ListForm.CreditLabel.Caption:=''
  else
    ListForm.CreditLabel.Caption:='';
  if GetDiscountMode = 1 then
    ListForm.DiscountLabel.Caption:=IntToStr(cbGetDiscountValue)+'%'
  else
    ListForm.DiscountLabel.Caption:='';
  if cbGetReturnMode = 1 then
    ListForm.TypePanel.Caption:='    '+
                                FormatFloat('0.00 ''.''',cbGetSum)
  else
    ListForm.TypePanel.Caption:='    '+
                                FormatFloat('0.00 ''.''',cbGetSum);
  ListForm.ShowModal;
end;

//------------------------------------------------------------------------------
//                          
//------------------------------------------------------------------------------
procedure TDemoForm.CheckParamButtonClick(Sender: TObject);
begin
  CheckParamForm.ShowModal;
end;

//------------------------------------------------------------------------------
//                        
//------------------------------------------------------------------------------
procedure TDemoForm.GetCashSumButtonClick(Sender: TObject);
var
  TempVar: Double;
begin
  if GetCashSum(TempVar) <> 1 then
    begin
      ShowMessage(GetErrorMsg);
      Exit;
    end;
  ShowMessage('    = '+FormatFloat('0.00 ''.''',TempVar));
end;

//------------------------------------------------------------------------------
//                         
//------------------------------------------------------------------------------
procedure TDemoForm.GetKKMNumButtonClick(Sender: TObject);
var
  TempVar: Integer;
begin
  if GetKKMNum(TempVar) <> 1 then
    begin
      ShowMessage(GetErrorMsg);
      Exit;
    end;
  ShowMessage('   = '+IntToStr(TempVar));
end;

//------------------------------------------------------------------------------
//                    
//------------------------------------------------------------------------------
procedure TDemoForm.GetKLNumButtonClick(Sender: TObject);
var
  TempVar: Integer;
begin
  if GetKLNum(TempVar) <> 1 then
    begin
      ShowMessage(GetErrorMsg);
      Exit;
    end;
  ShowMessage('    = '+IntToStr(TempVar));
end;

//------------------------------------------------------------------------------
//      (     )
//------------------------------------------------------------------------------
procedure TDemoForm.GetNIButtonClick(Sender: TObject);
var
  TempVar: Double;
begin
  if GetNI(TempVar) <> 1 then
    begin
      ShowMessage(GetErrorMsg);
      Exit;
    end;
  ShowMessage('  = '+FormatFloat('0.00 ''.''',TempVar));
end;

//------------------------------------------------------------------------------
//              
//------------------------------------------------------------------------------
procedure TDemoForm.GetSaleNumButtonClick(Sender: TObject);
var
  TempVar: Integer;
begin
  if GetSaleNum(TempVar) <> 1 then
    begin
      ShowMessage(GetErrorMsg);
      Exit;
    end;
  ShowMessage('       = '
              +IntToStr(TempVar));
end;

//------------------------------------------------------------------------------
//                          
//------------------------------------------------------------------------------
procedure TDemoForm.GetKKMVersButtonClick(Sender: TObject);
begin
  ShowMessage('   = '+FloatToStr(GetKKMVers));
end;

//------------------------------------------------------------------------------
//                  
//------------------------------------------------------------------------------
procedure TDemoForm.ReadSaleFromKLButtonClick(Sender: TObject);
var
  Section, Credit, Discount, Cashier, StartCheck, H, M, Operation: Integer;
  Sum: Double;
  TempStr: String;
begin
  NumEditForm.InfoLabel.Caption:='  ';
  NumEditForm.ShowModal;
  DemoForm.Refresh;
  if ReadSaleFromKL(NumEditForm.SpinEdit.Value, Operation, Section,
                    Cashier, Discount, Credit, StartCheck, H, M, Sum) <> 1 then
    begin
      ShowMessage(GetErrorMsg);
      Exit;
    end;
  TempStr:='  - ';
  if StartCheck = 1 then
    TempStr:=TempStr + '' + #13#10
  else
    TempStr:=TempStr + '' + #13#10;
  TempStr:=TempStr + ' - ';
  case Operation of
    1: TempStr:=TempStr + '' + #13#10;
    2: TempStr:=TempStr + '' + #13#10;
    3: TempStr:=TempStr + ' ' + #13#10;
    4: TempStr:=TempStr + ' ' + #13#10;
  end;
  TempStr:=TempStr + '   - ' + FormatFloat('00', H) +
           ':' + FormatFloat('00', M) + #13#10;
  TempStr:=TempStr + '  ' + IntToStr(Cashier) + #13#10;
  TempStr:=TempStr + '  ' + IntToStr(Section) + #13#10;
  TempStr:=TempStr + '  - ';
  if Credit = 1 then
    TempStr:=TempStr + '' + #13#10
  else
    TempStr:=TempStr + '' + #13#10;
  TempStr:=TempStr + '/ = ' + IntToStr(Discount) + '%' + #13#10;
  TempStr:=TempStr + '  / = ' + FormatFloat('0.00', Sum);
  ShowMessage(TempStr);
end;

//------------------------------------------------------------------------------
//                        
//------------------------------------------------------------------------------
procedure TDemoForm.LockButtonClick(Sender: TObject);
begin
  Lock;
  ShowMessage(GetErrorMsg);
end;

//------------------------------------------------------------------------------
//                      
//------------------------------------------------------------------------------
procedure TDemoForm.UnLockButtonClick(Sender: TObject);
begin
  UnLock;
  ShowMessage(GetErrorMsg);
end;

//------------------------------------------------------------------------------
//             
//------------------------------------------------------------------------------
procedure TDemoForm.SendSalesButtonClick(Sender: TObject);
begin
  SendSales;
  ShowMessage(GetErrorMsg);

end;

//------------------------------------------------------------------------------
//                       
//------------------------------------------------------------------------------
procedure TDemoForm.KKMPrintStrButtonClick(Sender: TObject);
begin
  LineEditForm.Edit.MaxLength:=23;
  if LineEditForm.ShowModal <> mrOk then Exit;
  if KKMPrintStr(PChar(LineEditForm.Edit.Text))<>1 then
    ShowMessage(GetErrorMsg);
end;

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
end.
