unit SaleEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TSaleForm = class(TForm)
    NameEdit: TEdit;
    OkButton: TButton;
    CancelButton: TButton;
    Label1: TLabel;
    Label2: TLabel;
    PriceEdit: TEdit;
    QtyEdit: TEdit;
    SectionEdit: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    procedure OkButtonClick(Sender: TObject);
    procedure PriceEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SaleForm: TSaleForm;

implementation

{$R *.DFM}

procedure TSaleForm.OkButtonClick(Sender: TObject);
var
  i, SepCount: Integer;
begin
  SepCount:=0;
  for i:=1 to Length(PriceEdit.Text) do
    if PriceEdit.Text[i]=DecimalSeparator then Inc(SepCount);
  if SepCount>1 then
    begin
      Application.MessageBox('  .', '',
                             MB_ICONERROR+MB_OK);
      PriceEdit.SetFocus;                        
      Exit;                    
    end;
  SepCount:=0;
  for i:=1 to Length(QtyEdit.Text) do
    if QtyEdit.Text[i]=DecimalSeparator then Inc(SepCount);
  if SepCount>1 then
    begin
      Application.MessageBox('  .', '',
                             MB_ICONERROR+MB_OK);
      QtyEdit.SetFocus;
      Exit;
    end;
  ModalResult:=mrOk;
end;

procedure TSaleForm.PriceEditKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key>='0') and (Key<='9') then Exit;
  if Key=DecimalSeparator then Exit;
  if Key=#8 then Exit;
  Key:=#7;
end;

procedure TSaleForm.FormActivate(Sender: TObject);
begin
  NameEdit.Text:=' ';
  PriceEdit.Text:='25'+DecimalSeparator+'50';
  QtyEdit.Text:='1'+DecimalSeparator+'000';
  SectionEdit.Value:=1;
  NameEdit.SetFocus;      
end;

end.
